#!/usr/bin/env python

from string import *
from ephem import *
from masks import normalcoord
from os import times
from basics import divz, rdarg, verbex
from numpy.core.numerictypes import *
import numpy
from numpy.oldnumeric import *
from FITS import FITS, C
from sys import argv, exit

ge=greater_equal
le=less_equal

#TableTypes = [C.TLOGICAL,C.TSTRING,C.TBIT,C.TSHORT,C.TINT,C.TLONG,C.TFLOAT,C.TDOUBLE,C.TLONGLONG,C.TBYTE]
TableTypes = [C.TLOGICAL,C.TSTRING,C.TBIT,C.TSHORT,C.TINT,C.TLONG,C.TFLOAT,C.TDOUBLE,81,11]
TableReads = [C.read_col_sht, C.read_col_byt, C.read_col_bit, C.read_col_sht,C.read_col_lng, C.read_col_lng,
                C.read_col_flt, C.read_col_dbl, C.read_col_lng, C.read_col_byt]

####################

def getcol(P,k,rows,naxis1,vnul=0.0,wid=0,verb=0):
  t=TableTypes
  f=TableReads
  s,ty,cwid,nc=C.get_coltype(P,k)
  if not wid: wid = cwid
  if ty == C.TSTRING:
#     s,a = f[t.index(ty)](P,k,1,1,rows*wid," ")
     a = []
     for row in range(rows):
#        s,a1 = row,C.read_col_byt(P,k,row+1,1,wid,0)
        s,a1 = row,C.read_col_byt(P,k,row+1,1,wid,0)
        if verb:
          print row,rows,a1
        if a1[0]:
          a1 = ""
        else:
          a1 = a1[1:]
          a1 = asarray(a1,int8).tostring()
        a.append(a1)
  else:
     if ty in [C.TLOGICAL,C.TINT,C.TSHORT,C.TLONG,C.TSTRING,81,11]: vnul = int(vnul)
#     elif ty in [C.TLOGICAL]: vnul = None
     if vnul == None:
        s,a = f[t.index(ty)](P,k,1,1,rows*wid)
     else:
        s,a = f[t.index(ty)](P,k,1,1,rows*wid,vnul)
     if wid > 1: a = reshape(a,(rows,wid))
     if verb:
        print s,a[0]
  return a

def readFITStable(efile,hdu,verb=0,read=1):
   hdu+=1
   F=FITS(efile,readonly=1)
   P=F.fitsfile()
   C.movabs_hdu(P,hdu)
   s,rows=C.get_num_rows(P)
   s,naxis1,comment=C.read_key(P,C.TLONG,"naxis1")
   s,cols=C.get_num_cols(P)
   if verb: print "Rows,Cols,NAXIS1=",rows,cols,naxis1
   names=map(lambda c: C.read_key_str(P,"TTYPE"+str(c+1))[1], range(cols))
   desc=map(lambda c: C.read_key_str(P,"TTYPE"+str(c+1))[2], range(cols))
   forms=map(lambda c: C.read_key_str(P,"TFORM"+str(c+1))[1], range(cols))
   tcrvl=map(lambda c: C.read_key_flt(P,"TCRVL"+str(c+1))[1], range(cols))
   tcrpx=map(lambda c: C.read_key_flt(P,"TCRPX"+str(c+1))[1], range(cols))
   tcdlt=map(lambda c: C.read_key_flt(P,"TCDLT"+str(c+1))[1], range(cols))
   tunits=map(lambda c: C.read_key_str(P,"TUNIT"+str(c+1))[1], range(cols))

   descr={"size":(cols,rows), "names":names, "desc":desc, \
      "forms":forms, "tcrvl":tcrvl, "tcrpx":tcrpx, \
      "tcdlt":tcdlt, "tunits":tunits}
   table={}
   if verb: print names
   if verb: print forms
   if read:
     for n in names:
         j=names.index(n); c=1+j
         if verb: print n, c, rows, C.get_coltype(P,c)
         vn = verb
         table[n] = getcol(P,c,rows,naxis1,verb=vn)
   F.close()
   return descr,table

