
from os import path
from Expector import *
from sys import stdout
from SimpleQueue import *
from TwistedHub import *

def dosplev(x,t):
   if len(x):
      i = argsort(x)
      a = take(x,i)
      v = zeros(x.shape,float64)
      put(v,i,splev(a,t))
      return v
   else: return zeros((0,),float64)

def RunObject(yexfile,doob,w10=0,w20=0,dw=0,pars={}):
   for key,val in pars.items():
      print "%s=%r"%(key,val),
      globals().__setitem__(key,val)
   if pars: print
#   if w10==w20 or dw==0: return None
   objtable=readtable(yexfile,tcols=[0,1,4])
   objimages,objnames,objcens = objtable[:3]
   noi = len(objimages)
   print doob
   images = [objimages[j] for j in range(noi) if objnames[j] == doob]
   ucens = asarray([objcens[j] for j in range(noi) if objnames[j] == doob])
   ucens = ucens - 1
#   k2 = 2*my+1
   k2 = 3
   print "Images=",images
   print "Input Centers=",ucens
   print
   shifts = (ucens[0] - ucens)

   tim0 = time.time()
   print "Images=",images
   print "Input Centers=",ucens
   print "Shifts=",shifts
   print

   doslits = []
   doimages = []
   ybegins = []
   yfinishes = []
   utyp = "cen"
   for image in images:
      allinfo = asarray(getslitinfo(image))
      jimage = images.index(image)
      okay = between(ucens[jimage],allinfo[0]-1,allinfo[1])
      okay = logical_or(okay,between(ucens[jimage]-fwhm,allinfo[0]-1,allinfo[1]))
      okay = logical_or(okay,between(ucens[jimage]+fwhm,allinfo[0]-1,allinfo[1]))
#      print ucens
#      print allinfo[0]
#      print allinfo[1]
#      print okay
      if sum(okay):
         doslit = nonzero(okay)[0]
         ybegin = int(allinfo[0][doslit] + shifts[images.index(image)])
         yfinish= int(allinfo[1][doslit] + shifts[images.index(image)])
         doimages.append(jimage)
#         print doimages
#         exit()
         doslits.append(doslit)
         ybegins.append(ybegin)
         yfinishes.append(yfinish)

   ysections = [ybegins[0]]

   sumname = doob+"%ssum.fits" % (suff)
   sigimage = replace(sumname,".fits","sig.fits")
   skyimage = replace(sumname,".fits","sky.fits")
   extimage = replace(sumname,".fits","ext.fits")
   if outdir:
      sumname = "%s/%s" % (outdir,sumname)
      sigimage = "%s/%s" % (outdir,sigimage)
      skyimage = "%s/%s" % (outdir,skyimage)
      extimage = "%s/%s" % (outdir,extimage)
      if not os.path.exists(outdir):
         os.mkdir(outdir)

   tim0 = time.time()

   imweight = []
   imtimes = []
   gotweights = None
   for ysection in ysections:
       multiud = []
       multiyuse = []
       multigood = []
       multigood2 = []
       multimud = []
       multiymud = []
       multimud2 = []
       multiymud2 = []
       multiwud = []
       multiiwud = []
       multibud = []
       multieud = []
       xshifts = []
       yshifts = []
       ystart = ysection
       yend = yfinishes[0]
       print
       for jimage in doimages:
            image = images[jimage]
            ucen = ucens[jimage]
            print "Working on image #%d (%s)." % (jimage+1,image)
            if extradat0:
               if [c for c in "[]" if c in extradat0]:
                  extradat = image.replace("fo.fits","m.fits")
                  for efn in eval(extradat0):
                      extradat = extradat.replace(efn[0],efn[1])
                  print "Working on image #%d (%s)." % (jimage+1,extradat)
               else: extradat = extradat0
            f=FITS(image); nslits=f["nslits"]
            mudout = f["x-rect"]
            ymudout = f["y-dist"]
            xdcor = (f["xdcor"] == "1")
            ydcor = (f["ydcor"] == "1")
            if xdist: npy,nupy,nt,xord,yord=eval(f["x0xfmn"])
            naxes=f.naxes()
            f.close()
            naxis1,naxis2=naxes
            ca,cb=getslitinfo(image); npy=int(nslits); upy = None
            ca = subtract(ca,1)
            cb = subtract(cb,1)
            if extradat0:
               extca, extcb = getslitinfo(extradat)
               extca = subtract(extca,1)
               extcb = subtract(extcb,1)
            ca = clip(ca,0,naxis2-1)
            cb = clip(cb,1,naxis2)
            sca = 1*ca
            scb = 1*cb
            ymca,ymcb=ca,cb
            imin = image
            okay = between(ucen,ca,cb)
            okay = logical_or(okay, between(ucen-fwhm,ca,cb))
            okay = logical_or(okay, between(ucen+fwhm,ca,cb))
            nupy = nonzero(okay)[0]
            suf = join(["_",str(zfill(nupy+1,3)),"_"],"")
            f=FITS(image)
            exptime = f["exptime"]
            ecord = f["ecord%d" % (nupy)]
            if exptime == "N/A":
              exptime = f["elaptime"]
              if exptime == "N/A" and f["original"] != "N/A":
                 original = f["original"]
                 fo = FITS(original)
                 exptime = fo["exptime"]
                 fo.close()
            skyim = f["skyim"]
            if skyim == "N/A":
               print "error! no skyim for %s!" % (image)
               return
            if not os.path.exists(skyim):
               skyim = os.path.dirname(image)+"/"+skyim
            g = FITS(skyim)
            if extradat0: gextra = FITS(extradat)
            ymudout = f["y-dist"]
            if not os.path.exists(ymudout):
               ymudout = os.path.dirname(image)+"/"+ymudout
            yfm=FITS(ymudout)

            if not gotweights and not escale:
                 if utyp == "cen":
                    rucen = ucen
                    rnupy = nupy
                 else:
                    robs = nonzero([objtypes[job] == "cen" for job in range(noi)])
                    refims = [objimages[job] for job in robs]
                    refobs = [objnames[job] for job in robs]
                    print "Using",refobs[jimage],"as references."
                    refcens = take(objcens,robs)
                    refwids = take(objwids,robs)
                    rucen = refcens[jimage]
                    rnupy = nonzero(between(rucen,ca,cb))[0]
                 onewca = int(max([rucen-fwhm,ca[rnupy]]))
                 onewcb = int(min([rucen+fwhm,cb[rnupy]]))
                 oymca = ymca[rnupy] + (onewca-ca[rnupy])
                 oymcb = ymcb[rnupy] + (onewcb-cb[rnupy])
                 oca = onewca
                 ocb = onewcb
                 smax = lambda a: 2*max(abs(compress(isfinite(a),a,0)))
                 ud0 = max([0,int(oca - smax(yfm.row(oca)))])
                 ud1 = min([naxis2-1,int(ocb + smax(yfm.row(ocb))+1)])
                 yd0 = max([0,int(oymca - smax(yfm.row(oymca)))])
                 yd1 = min([naxis2-1,int(oymcb + smax(yfm.row(oymcb))+1)])
                 ud = f.readsec((0,ud0),(naxis1-1,ud1-1))
                 bud = g.readsec((0,ud0),(naxis1-1,ud1-1))
                 ymud = yfm.readsec((0,yd0),(naxis1-1,yd1-1))
                 odat = rebin(ud,zeros(ymud.shape,float32),ymud,data=1,cubic=0,verb=0)
                 onorm = sort(odat.ravel())
                 onorm = sum(onorm[len(onorm)/4:int(0.99*len(onorm))])
                 oprof = median(transpose(odat)[naxis1/3:naxis1-naxis1/3])
                 if bord1:
                    oprof = oprof[bord1:]
                 if bord2:
                    oprof = oprof[:-bord2]
                 oloc = argmax(oprof) + (ud0+bord1)
                 if not fixpos:
                    shifts[jimage] = shifts[jimage] + (rucen - oloc) + 1
                    print "new shift",shifts[jimage]
            elif not gotweights:
               onorm = 1.0

            newca = max([int(ystart)-k2,0])
            newcb = min([int(yend)+k2,naxis2])
            print newca,newcb
            ymca[nupy] = ymca[nupy] + (newca-ca[nupy])
            ymcb[nupy] = ymcb[nupy] + (newcb-cb[nupy])
            ca[nupy] = newca
            cb[nupy] = newcb
            okay=1

            if jimage == doimages[0]:
               masterca = 1*ca[nupy]
               mastercb = 1*cb[nupy]
               masterce = sca[nupy]
               masterna = (scb[nupy] - sca[nupy] + 1,naxis1)
               mastern1 = naxis1
               mastern2 = naxis2

            S=readsol(image,"y0xfm")
            yzord = 0
            if len(S) == 5: dum1,dum2,ysol,yxord,yyord=S
            elif len(S) == 6: dum1,dum2,ysol,yxord,yyord,yzord=S
            ysol=ysol[0]
            print "Reading from rows %d to %d" % (newca,newcb)
            stdout.flush()
            smax = lambda a: 2*max(abs(compress(isfinite(a),a,0)))
            ud0 = max([0,int(ca[nupy] - smax(yfm.row(ca[nupy])))])
            ud1 = min([naxis2-1,int(cb[nupy] + smax(yfm.row(cb[nupy]-1))+1)])
            yd0 = max([0,int(ymca[nupy] - smax(yfm.row(ymca[nupy])))])
            yd1 = min([naxis2-1,int(ymcb[nupy] + smax(yfm.row(ymcb[nupy]-1))+1)])
            if jimage == doimages[0]:
               masterud0 = ud0
               masterud1 = ud1
#            else:
#               if ud1-ud0 != (masterud1-masterud0):
#                   ud1 = ud0 + (masterud1-masterud0)
#               if yd1-yd0 != (masterud1-masterud0):
#                   yd1 = yd0 + (masterud1-masterud0)

            nca = newca-ud0
            ncb = ud1-newcb

#            if jimage == doimages[0]:
#               objpos = ucen - (ud0+1)

            ud = f.readsec((0,ud0),(naxis1-1,ud1-1))
            if skyim != "N/A": bud = g.readsec((0,ud0),(naxis1-1,ud1-1))
            else: bud = zeros(ud.shape,float32)
            if extradat0: eud = gextra.readsec((0,ud0+extca[nupy]-sca[nupy]),(naxis1-1,ud1-1+extca[nupy]-sca[nupy]))
            else: eud = zeros(ud.shape,float32)
            ymud = yfm.readsec((0,ud0),(naxis1-1,ud1-1))
            yfm.close()
            dud = (masterud1-masterud0)-(ud1-ud0)
            if jimage != doimages[0] and dud:
               print "DUD",jimage,dud
               if dud > 0:
                  ud = concatenate([ud,asarray(dud*[-999+0.0*ud[-1]])])
                  if skyim != "N/A":
                     bud = concatenate([bud,asarray(dud*[bud[-1]])])
                  if extradat0:
                     eud = concatenate([eud,asarray(dud*[eud[-1]])])
                  ymud = concatenate([ymud,asarray(dud*[ymud[-1]])])
               elif dud < 0:
                  ud = ud[:dud]
                  if skyim != "N/A":
                     bud = bud[:dud]
                  if extradat0:
                     eud = eud[:dud]
                  ymud = ymud[:dud]
                  scb[nupy] = min([scb[nupy], ud.shape[0]])

#            print jimage,ud0,ud1-1,naxis2
#            print jimage,max(abs(ymud).ravel())
#            print ymud.shape,ud.shape
#            print sca
#            print scb
#            print sca[nupy],scb[nupy]
#            print sca[nupy]-ud0
#            print scb[nupy]-1-ud0

            dum1,dum2, xdsol, xdord, ydord = readsol(image,"x%dxfm" % (nupy))
            xdyy, xdxx = arange(0,ud.shape[0],1,float32), arange(0,ud.shape[1],1,float32)
            xdyy = xdyy - nca - k2
            xdn = [scb[nupy]-sca[nupy] + 0,naxis1]
            mud = asarray([getmap(xdord,ydord,xdsol[0],xdxx,xdyy[xy1]*ones(xdxx.shape),xdn) for xy1 in range(len(xdyy))])
        
#            if yzord:
#              cymuda = getmap(yzord,yyord,ysol,nupy*ones(xdxx.shape),xdxx,[naxis1,nslits])
#              cymudb = getmap(yzord,yyord,ysol,nupy*ones(xdxx.shape),xdxx,[naxis1,nslits])
#            else:
#              cymuda = getmap(yxord,yyord,ysol,sca[nupy]*ones(xdxx.shape),xdxx,[naxis1,naxis2])
#              cymudb = getmap(yxord,yyord,ysol,scb[nupy]*ones(xdxx.shape),xdxx,[naxis1,naxis2])
            cymuda = ymud[int(sca[nupy])-ud0]
            cymudb = ymud[int(scb[nupy]-1)-ud0]

            dum1,dum2,sol,xord,yord=readsol(image,"x"+str(nupy)+"xfm")
            sol=sol[0]
            f.close()
            if skyim != "N/A": g.close()
            if extradat0: gextra.close()

            if jimage == doimages[0]:
               mastersol = sol
               masterxord = xord
               masteryord = yord
               masterysol = ysol
               masteryxord = yxord
               masteryyord = yyord
               mastermud = mud
               masterymud = ymud

            if wdist:
               dum1,dum2,wsol,dum3,wbtype=readsol(image,"w"+str(nupy)+"xfm")
               wsol=wsol[0]
            else:
               w10 = 0.0
               w20 = 1.0*naxis1
               dw = 1.0
               wbtype = 0
               wsol=array([naxis1/2.0,naxis1/2.0])

            yo, xo = indices(ud.shape,float32)
            yco, xco = indices(ud.shape,float32)

            xu = arange(0,naxis1,1,float32)
            if wbtype == 1:
              xx = (2*(xu+1.0)-(1+naxis1))/(naxis1-1)
              xche = chebyshev(xx,len(wsol)-1)
              wx = add.reduce(wsol*transpose(xche),1)
            else:
              xc = (xu[0] + xu[-1])/2.0
              xw = (xu[-1] - xu[0])/2.0
              xx = (xu-xc)/xw
              xleg = legendre(xx,len(wsol)-1)
              wx = add.reduce(wsol*transpose(xleg),1)
            if logb: wx = log10(wx)
            wo0,wo1 = wx[0], wx[-1]

            if less(diff(wx),0).any():
               print "Problem with wavelength solution for",image
               print wx
               return

            wtck = splrep(wx,xu,s=0,k=3)
            xtck = splrep(xu,wx,s=0,k=3)

            if jimage == doimages[0]:
                 if defsample:
                    w1,w2 = wo0,wo1
#                    sw1 = int(max(abs(mastermud[nca:scb[nupy]-sca[nupy]+nca-1,0])))+2
#                    sw2 = int(max(abs(mastermud[nca:scb[nupy]-sca[nupy]+nca-1,-1])))+2
#                    w1,w2 = wx[sw1],wx[-sw2]
                    nw = int(naxis1)
                    dw = (w2-w1)/nw
                 else:
                    nw = int((w20-w10)/dw+0.5)
                    if logb:
                       w1,w2 = log10([w10,w20])
                       dw = (w2-w1)/nw
                    else:
                       w1,w2 = w10,w20
                       dw = (w2-w1)/nw
                 wa = arange(nw)*dw + w1
                 xout = splev(wa,wtck)
                 dxout = diff(xout)
                 dxout = concatenate([dxout,[dxout[-1]]])
                 mwtck = wtck
                 mwx = wx

            yco = yco + ud0
            yuse = between(yco,sca[nupy]+cymuda+bord1,scb[nupy]+cymudb-1-bord2,inc=1)
            for ymask in ymasks: yuse = yuse*logical_not(between(yco,ymask[0],ymask[1],inc=1))

            if logb: wxfm=[wbtype,wsol,w10,w20,(w20-w10)/nw,logb]
            else: wxfm=[wbtype,wsol,w1,w2,dw,logb]
            mud,good = wavemapping(mud,wxfm)
#            print jimage,wsol,mud.shape,good.shape
#            print jimage,max(abs(ymud).ravel())
            ymud = wavemapping(ymud,wxfm,ydist=1)[0]
#            print jimage,max(abs(ymud).ravel())
#            ymud = ymud - shifts[jimage]
#            ymud = rebin(ymud,mud,zeros(mud.shape,float32),data=0,mirror=1,verb=0)

            mudc1,mudc0 = indices(mud.shape,float32)
            mud2c1,mud2c0 = indices((mud.shape[0]*ysubs,mud.shape[1]*xsubs),float32)
            good = good*between(mudc1,nca-1,nca-1+(newcb-newca),inc=1)

            mud2 = VTKGrowN(mud+mudc0,n=xsubs,m=ysubs,numret=1,interp=1,xshift=-(xsubs-1)/2.,yshift=-(ysubs-1)/2.)-mud2c0
            ymud2 = VTKGrowN(ymud+mudc1,n=xsubs,m=ysubs,numret=1,interp=1,xshift=-(xsubs-1)/2.,yshift=-(ysubs-1)/2.)-mud2c1
            good2 = VTKGrowN(good,n=xsubs,m=ysubs,numret=1,interp=1,xshift=-(xsubs-1)/2.,yshift=-(ysubs-1)/2.)
#            print jimage,max(abs(ymud+mudc1-mud2c1).ravel()),max(abs(ymud2).ravel())
#            good2 = good2*isfinite(mud2)*isfinite(ymud2)
#            mud2 = where(good2,mud2,0)
#            ymud2 = where(good2,ymud2,0)

            xshift = bwt(splev(mwx,wtck)[:len(xu)] - xu[:len(mwx)])

            xshifts.append(xshift[0])
            yshifts.append(shifts[jimage])

            origud = 1*ud
            print "Rescaling by pixel area."
            print "Worry about cosmic rays?"
#            oud = VTKAniModel(ud,mx=mx,my=my,fac=0.4,iter=25)
            oud = VTKMedian(ud,mx,my,numret=1)

            obud = where(greater(bud,0),bud,0) + where(greater(oud,0),oud,0)
            nud = getsqrt(obud/adu + pow(rn/adu,2))

            if ccut:
                onud = 1.49*VTKMedian(abs(ud-oud),mx,my,numret=1)
                rnud = divz(ud-oud,onud)
                inud = sqrt(1 + power(rnud/ccut,2))
            else: inud = 1.0

            if uniform: nud = mean(nud.ravel())*ones(nud.shape)

            if yuse.any():
                wud = divz(yuse,nud)
                iwud = divz(wud,inud)

#                if jimage == doimages[0]:
#                  qdump("ud.fits",ud)
#                  qdump("yuse.fits",yuse*ud)
#                  qdump("oud.fits",oud)
#                  qdump("rnud.fits",rnud)
#                  exit()

                multiud.append(ud)
                multibud.append(bud)
                multieud.append(eud)
                multimud.append(mud)
                multiymud.append(ymud)
                multimud2.append(mud2)
                multiymud2.append(ymud2)
                multigood.append(good)
                multigood2.append(good2)
                multiwud.append(wud)
                multiiwud.append(iwud)

            if not gotweights:
               imweight.append(onorm)
               imtimes.append(exptime)

       lenw = len(multiud)
       if lenw:
           print
           print "Let's try to put it all together."
#           yshifts = subtract(yshifts,yshifts[0])
           yshifts = subtract(yshifts,median(yshifts))
           print "Shifts=",yshifts
           for j in range(lenw):
               multiymud[j] = multiymud[j] - yshifts[j]
               multiymud2[j] = multiymud2[j] - yshifts[j]
   
           if escale: imweight = asarray(imtimes); print "Times"
           else: imweight = asarray(imweight); print "Fluxes"
           print imweight
           print
           print "Total"
           print sum(imweight)
           print
           print "Weights"
           doweight = imweight / mean(imweight)
#           doweight[0] = 0*doweight[0]
#           doweight[1] = 0*doweight[1]
#           doweight[2] = 0*doweight[2]
#           doweight[3] = 0*doweight[3]
#           doweight = doweight * 0 + 1
           print doweight
           gotweights = 1
           print
           totaltime = sum(imtimes)
           ybot, ytop = int(nca+k2-1), int(multiud[0].shape[0]-ncb-k2+1)

           cubic = 0

           multiud = [divz(multiud[j],doweight[j]).astype(float32) for j in range(lenw)]
           multiwud = [(multiwud[j]**2*(doweight[j])).astype(float32) for j in range(lenw)]

           for npass in range(spass):
                ucut = ncut*(spass-npass)
                print "Npass, Cut = ", npass+1,ucut
                numer, denom = [], []
                numer2, denom2 = [], []
                numer3, denom3 = [], []
                for j in range(lenw):
                   if ucut:
                     if npass == 0:
                         f1,f2 = 0.0,0.0
                         for j2 in range(lenw):
                            if j2 != j:
                              if verb: print "(%d,%d)" % (j,j2)
#                              print j2,max(abs(multiymud2[j2]).ravel())
                              f1 += sqrt(doweight[j2])*rebin(multiud[j2],multimud2[j2],multiymud2[j2],data=1,cubic=0,mirror=1,verb=0)
                              f2 += sqrt(doweight[j2])
                         f12 = divz(f1,f2)
                     ir = reversebin(f12,multimud2[j],multiymud2[j],origsize=multiud[j].shape,data=1,cubic=0,mirror=1)
                     ir = divz(ir,doweight[j])
#                     qdump("ud%d.fits" % (j),multiud[j])
#                     qdump("ir%d.fits" % (j),ir)
                     dr = ((multiud[j]-ir)*sqrt(multiwud[j])).astype(float32)
                     sdr = 1.49*VTKMedian(abs(dr),mx,my,numret=1)
#                     qdump("sdr%d.fits" % (j),sdr)
                     edr = divz(1,sdr).astype(float32)
#                     qdump("rdr%d.fits" % (j),dr*edr)
                     bad = greater(dr*edr,ucut).astype(float32)
#                     bad = logical_or(bad,less(dr*edr,ucut).astype(float32))
                     bad = VTKGauss(bad,ngrow/2.0,1)
                     uwts = 1.*less_equal(bad,1.0/(2*pi)/(ngrow/2.0)**2*exp(-1.0))
#                     uwts = 1.*less_equal(bad,0.0625)
#                     bad = VTKConvolve(bad,k=ngrow,numret=1)
#                     if ngrow == 3: uwts = 1.*less_equal(bad,0.25**2)
#                     elif ngrow == 5: uwts = 1.*less_equal(bad,0.0625**2)
#                     qdump("bad%d.fits" % (j),10000.*(1-uwts))
                   else:
                     uwts = ones(multiud[j].shape,float32)
#                   uwts = uwts * multigood[j]
                   if npass != spass-1:
                      f12 = rebin(multiud[j],multimud[j],multiymud[j],data=1,cubic=cubic,mirror=1,verb=0)
                      of12 = 1.*greater(rebin(uwts,multimud[j],multiymud[j],data=0,cubic=cubic,mirror=1,verb=0),0.74)
                      of12 = of12 * multigood[j]
                      um = divz(1,multiwud[j]).astype(float32)
                      df12 = getsqrt(rebin(um,multimud[j],multiymud[j],data=0,cubic=cubic,mirror=1,verb=0))
                      df12 = df12*of12
                   else:
                      f12 = rebin(multiud[j],multimud2[j],multiymud2[j],data=1,cubic=cubic,mirror=1,verb=0)
                      of12 = 1.*greater(rebin(uwts,multimud2[j],multiymud2[j],data=0,cubic=cubic,mirror=1,verb=0),0.74)
                      of12 = of12 * multigood2[j]
#                      f12 = 9999.*multigood2[j]
                      um = divz(1,multiwud[j]).astype(float32)
                      df12 = getsqrt(rebin(um,multimud2[j],multiymud2[j],data=0,cubic=cubic,mirror=1,verb=0))
                      df12 = df12*of12
                      f12 = VTKShrinkN(f12,n=xsubs,m=ysubs,numret=1,usemean=1)*(xsubs*ysubs)
                      df12 = VTKShrinkN(df12,n=xsubs,m=ysubs,numret=1,usemean=1)*(xsubs*ysubs)
                      bf12 = rebin(multibud[j],multimud2[j],multiymud2[j],data=1,cubic=cubic,mirror=1,verb=0)
                      bf12 = VTKShrinkN(bf12,n=xsubs,m=ysubs,numret=1,usemean=1)*(xsubs*ysubs)
                      numer += [f12]
                      denom += [df12]
                      numer2 += [bf12]
                Numer, Numer2, Denom = 0.0, 0.0, 0.0
                for inumer in range(len(numer)):
                   Numer += divz(numer[inumer],denom[inumer])
                   Numer2 += divz(numer2[inumer],denom[inumer])
                   Denom += divz(1,denom[inumer])
                f12 = divz(Numer,Denom)
                bf12 = divz(Numer2,Denom)
           del numer, denom

           odatbig = f12 * greater(dxout,0) * lenw
           bdatbig = bf12 * greater(dxout,0) * lenw
           odatbig = odatbig[ybot:ytop]
           bdatbig = bdatbig[ybot:ytop]

           if extradat0:
              f12 = rebin(multieud[0],multimud2[0],multiymud2[0],data=1,cubic=cubic,mirror=1,verb=0)
              f12 = VTKShrinkN(f12,n=xsubs,m=ysubs,numret=1,usemean=1)*(xsubs*ysubs)
              f12 = multigood[0]*f12
              edatbig = f12 * lenw * greater(dxout,0)
              edatbig = edatbig[ybot:ytop]

           vdatbig = ((odatbig+bdatbig)/adu + lenw*pow(rn/adu,2)*dxout) * greater(dxout,0)
           sdatbig = getsqrt(vdatbig) * greater(dxout,0)


           ny = odatbig.shape[0]
           tim1 = time.time()
           elapsed = tim1-tim0
           print "Timing = %9.1f" % (elapsed)
           print

           for jp in range(3+(extradat0!=None)):
              ipdat = [odatbig,bdatbig,sdatbig]
              ipout = [sumname,skyimage,sigimage]
              if extradat0:
                 ipdat.append(edatbig)
                 ipout.append(extimage)
              jpdat = ipdat[jp]
              jpout = ipout[jp]

              print "Making %s." % (jpout)

              f = FITS(jpout,readonly=0,create=1)
#              f.newhead("T",-32,2,[nw,ny])
              f0 = FITS(images[0])
              f.copyheader(f0)
              f0.close()
              f.resize([nw,ny])
              f.modkey("nslits",1)
              f.modkey("csect1a",max([1,masterca-masterud0+1-ybot]))
              f.modkey("csect1b",min([ny,mastercb-masterud0+1-ybot]))
#              f.modkey("csect1b",f.naxes()[1])
              if ecord != "N/A": f.modkey("ecord0",ecord)
              f.modkey("origin",image)
              f.modkey("xdcor",1)
              f.modkey("ydcor",1)
#              f.modkey("objpos",ucen-sca[nupy]+1)
#              f.modkey("objpos",ucens[0]-sca[nupy]+1)
#              f.modkey("objpos",ucens[0]-masterce)
#              objpos = ucens[0]-sca[nupy]-median(yshifts)
              objpos = (ucens[0]+1)-masterud0-ybot
              print objpos,masterud0,masterca,mastercb,ny
              f.modkey("objpos",objpos)
              f.modkey("WAT0_001","system=world")
              f.modkey("WAT1_001","wtype=linear label=Wavelength units=Angstroms")
              f.modkey("WAT2_001","wtype=linear")
              f.modkey("dispaxis",1)
              f.modkey("ctype1","linear")
              f.modkey("ctype2","linear")
              if logb: f.modkey("dc-flag",1)
              else: f.modkey("dc-flag",0)
              f.modkey("crval1",w1)
              f.modkey("cdelt1",dw)
              f.modkey("cd1_1",dw)
              f.modkey("crpix1",1.0)
              f.modkey("ncombine",lenw)
              if exptime != "N/A":
                 f.modkey("exptime",totaltime)
                 f.modkey("elaptime",totaltime)
              f.putdata(jpdat)
              f.close()


