
from string import *
from sys import exit
from basics import *
from numpy.core.numerictypes import *
import numpy
if "USEGPGPLOT" in os.environ:
   from gpgplot import *
else:
   from cpgplot import *
import re
import os

def getpgdev():
   if os.environ.has_key('PGPLOT_DEV'): dev = os.environ['PGPLOT_DEV']
   else: dev = '/xwin'
   if os.environ.has_key('PGPLOT_SIZE'): size = float(os.environ['PGPLOT_SIZE'])
   else: size=8.0
   return dev,size

PGPLOT_DEV, PGPLOT_SIZE = getpgdev()

def opendev(dev,land=1,ask=1,nx=1,ny=1,asp=1.0,size=8,white=False):
	status = cpgopen(dev)
	if status <=0:
#           cpgend()
#	   status = cpgopen(dev)
           if status <=0: return os._exit(1)

        cpgscf(2)
	if land == 1:
          cpgpap(size,0.85)
	elif land == 2:
          cpgpap(size,1.1765)
	elif land == 0:
          cpgpap(size,asp)
        cpgask(ask)
        if white:
          cpgscr(0,1,1,1)
          cpgscr(1,0,0,0)

	cpgsubp(nx,ny)
	return status

def newco(oldgray,newgray,ngs=256.,ch=1.5,itf=0,box=1,color=0):
  if box:
     cpgsch(ch/2.)
     cpgsvp( 0.87,0.9,0.15,0.9)
     cpgsci(0)
     z1=oldgray[0]; z2=oldgray[1]; gd=0
     if oldgray[1] < oldgray[0]: z2=oldgray[0]; z1=oldgray[1]; gd=1
     if oldgray[1] != oldgray[0]:
       cpgswin(0,1,z1,z2)
       cpgbox('BC',0,0,'BCMV',0,0)
       cpgsvp( 0.87,0.9,0.15,0.9)
     cpgsci(1)
     z1=newgray[0]; z2=newgray[1]; gd=0
     if newgray[1] < newgray[0]: z2=newgray[0]; z1=newgray[1]; gd=1
     cpgswin(0,1,z1,z2)
     cpgbox('BC',0,0,'BCMV',0,0)
     if gd:
       gs=arange(z1,z2,(z2-z1)/ngs,float32)
     else:
       gs=arange(z2,z1,(z1-z2)/ngs,float32)
     gs=array(transpose(gs).tolist(),float32)
     gs = gs*ones((len(gs),1),float32)
#     for j in range(len(gs)):
#        cg = 1.0*j/ngs
#        cpgscr(15+j,cg,cg,cg)
     ts=array([-0.5,1.0,0.0,z2,0.0,(z1-z2)/ngs])
#     ts=array(transpose(ts).tolist(),float32)
#     ts = ts*ones((1,len(ts)),float32)
     cpgsvp( 0.87,0.9,0.15,0.9)
     cpgsitf(itf)
     if color: cpgimag(gs,1,len(gs),1,1,1,len(gs),z1,z2,ts)
     else: cpggray(gs,1,len(gs),1,1,1,len(gs),z1,z2,ts)
     cpgsvp( 0.1,0.85,0.15,0.9)

def showcont(fits,i1,i2,j1,j2,a1,a2,trf,contours,ls=1,ci=1,lw=1):
   contours = contours.astype(float32)
   n=fits['naxes']
   cpgslw(lw)
   cpgsls(ls)
   cpgsci(ci)
   cpgcont(fits['data'],n[0],n[1],i1+1,i2+1,j1+1,j2+1,contours,-len(contours),trf)
   cpgsls(1)
   cpgslw(1)
   cpgsci(1)

def prepcolors(np):
   nm0=pow(2,np*0)
   nm1=pow(2,np*1)
   nm2=pow(2,np*2)
   nm3=pow(2,np*3)
   H=arange(0,2*nm3,1,int32)
   L=arange( len(Hb)) /(len(Hb)-1.0)
   Hr=H/(nm1-1.0)
   Hg=H/(nm1-1.0)
   Hb=H/(nm1-1.0)
   cpgscir(16,16+nm3)
   la,lap=genpt(L)
   hr,hrp=genpt(Hr)
   hg,hgp=genpt(Hg)
   hb,hbp=genpt(Hb)
   cpgctab(lap,hrp,hgp,hbp,len(L),1.0,0.5)

def showtv(fits,i1,i2,j1,j2,a1,a2,trf,itf=0,color=0):
   n=fits['naxes']
   cpgsitf(itf)
   if color: cpgimag(fits['data'],n[0],n[1],i1+1,i2+1,j1+1,j2+1,a1,a2,trf)
   else: cpggray(fits['data'],n[0],n[1],i1+1,i2+1,j1+1,j2+1,a1,a2,trf)

def newtv(oldrange,newrange,ch=1.5,rotate=0,box=1):
        cpgsch(ch)
	if newrange != oldrange:
          cpgsci(0)
          cpgsvp( 0.1,0.85,0.15,0.9)
	  if rotate:
            cpgswin( oldrange[0],oldrange[1],oldrange[3],oldrange[2])
	  else:
            cpgswin( oldrange[0],oldrange[1],oldrange[2],oldrange[3])
          if box: cpgbox('BCSTN',0,0,'BCNST',0,0)
        cpgsci(1)
        cpgsvp( 0.1,0.85,0.15,0.9)
	if rotate:
         cpgswin( newrange[0],newrange[1],newrange[3],newrange[2])
	else:
         cpgswin( newrange[0],newrange[1],newrange[2],newrange[3])
	if box: cpgbox('BCSTN',0,0,'BCNST',0,0)

def newbox(xr,yr,ch=1.5,just=0,era=1,xlog=0,ylog=0,tax=1,rax=1,ytop=0.90,xs=0,ys=0,
    lw=1,manvp=0,ylab=1,xlab=1, ysub=1,time=0,nofirst=0,bax=1,lax=1,rb=0.95,ci=1):
        cpgsci(ci)
	if era: cpgpage()
#	if era: cpgeras()
        if not xs: xs=0.13*sqrt(ch/1.5)
        if not ys: ys=0.14*sqrt(ch/1.5)
        if not manvp: cpgsvp( xs,rb,ys,ytop)
        cpgsch(ch)
        cpgslw(lw)
	ystring="T"
	xstring=""
        if ysub: ystring += "S"
	if lax: ystring+='B'
	if rax: ystring+='C'
	if tax: xstring+='CST'
	if bax: xstring+='BS'
        if xlab and (tax or bax): xstring += "N"
        if ylab > 0 and lax: ystring += "N"
        if ylab > 0 and rax and not lax: ystring += "M"
        if ylab == 2: ystring += "V"
	if xlog and (tax or bax): xstring=xstring+'L'
	if ylog: ystring=ystring+'L'
	if just: cpgwnad( xr[0],xr[1],yr[0],yr[1])
#	if just: cpgwnad( min(xr),max(xr),min(yr),max(yr))
        else: cpgswin( xr[0],xr[1],yr[0],yr[1])
        if time%10 == 1 or time%10 == 3: xstring+="ZYX" + (time > 10)*"H" + (time > 20)*"O"
        if time%10 == 2 or time%10 == 3: ystring+="ZYX" + (time > 10)*"D" + (time > 20)*"O"
        if nofirst: xstring += "F"
        if nofirst: ystring += "F"
        if "giza" in os.environ["PGPLOT_DIR"]:
           cpgbox(xstring,0,0,ystring,0,0)
        else:
           cpgtbox(xstring,0,0,ystring,0,0)
        cpgslw(1)
        cpgsci(1)

def getmar(y,p=3,q=3,w=10.0):
    ag=argsort(y)
    n = 1.0*len(y)
    i1 = max(int(w*n/100),0)
    i2 = min(int(n-w*n/100),n-1)
    y1 = y[ag[i1]]
    y2 = y[ag[i2]]
    a1 = y1-(y2-y1)*(p*0.01)
    a2 = y2+(y2-y1)*(q*0.01)
    if a1==a2: a1=a1/2;a2=a2*1.5
    return [a1, a2]

def drawpts(x,y,p,ch=1.5,ci=1,lw=1):

        n=len(x)
	cpgsch(ch)
        cpgslw(lw)
        if len(shape(ci)) == 0:
          cpgsci(ci)
          cpgpnts(n,asarray(x),asarray(y),asarray(p),n)
        else:
          for j in range(n):
            cpgsci(ci[j])
            cpgpt1(x[j],y[j],p[j])
        cpgsci(1)
        cpgslw(1)

def drawptl(x,y,ids,ch=1.5,ci=1,lw=1,ang=0,fj=0.5,force=0):

        n=len(x)
	cpgsch(ch); cpgslw(lw)
        x1,x2,y1,y2 = cpgqwin()
        for i in range(n):
          if len(shape(ci)) > 0: cpgsci(ci[i])
          else: cpgsci(ci)
          if len(shape(ang)) > 0: angle=ang[i]
          else: angle=ang
          if len(shape(fj)) > 0: fjust=fj[i]
          else: fjust=fj
          if force or ((min([x1,x2]) <= x[i] <= max([x1,x2])) and (min([y1,y2]) <= y[i] <= max([y1,y2]))):
             cpgptxt(x[i],y[i],angle,fjust,str(ids[i]))
        cpgsci(1)
        cpgslw(1)

def drawptsz(x,y,p,ch,ci=1):
        x = asarray(x)
        y = asarray(y)
        p = asarray(p)

	if not len(shape(ci)): ci=ci*ones(x.shape)
        n=len(x)
	for i in range(0,n):
          if ci[i]:
            cpgsci(ci[i])
	    if p[i] == 9:
	      cpgsch(1); cpgpt1(x[i],y[i],17)
	      cpgsch(2); cpgpt1(x[i],y[i],4)
	    else: cpgsch((ch[i])); cpgpt1(x[i],y[i],p[i])
        cpgsci(1)

def markpts(i1,i2,j1,j2,xs,ys,ids,ch=0.7,ci=2,ang=0,fj=0.5,lw=1):

  n=len(xs)
  cpgslw(lw)
  cpgsch(ch)
  if len(shape(ci)) == 0: cpgsci(ci)
  cpgstbg(-1)

  i1,i2 = extrema([i1,i2])
  j1,j2 = extrema([j1,j2])
  for i in range(n):
    if (i1 < xs[i] < i2 ) and (j1 < ys[i] < j2):
        if len(shape(ci)) > 0: cpgsci(ci[i])
        if len(shape(ang)) > 0: angle=ang[i]
        else: angle=ang
        if len(shape(fj)) > 0: fjust=fj[i]
        else: fjust=fj
        cpgptxt(xs[i],ys[i],angle,fjust,str(ids[i]))
  cpgsci(1)
  cpgslw(1)

def drawpt1(x,y,ps=17,ch=1.5,ci=1,lw=1):
        cpgslw(lw)
        cpgsch(ch)
        cpgsci(ci)
        cpgpt1(x,y,ps)
        cpgsci(1)
        cpgslw(1)

def drawpterr(x,ex,y,ey,ps=17,ch=1.5,ci=1,lw=1,bar=0.1):
        x = asarray(x)
        y = asarray(y)
        ex = asarray(ex)
        ey = asarray(ey)

        n=len(x)
        cpgsch(ch)
        cpgslw(lw)
        if len(shape(ci)) > 0:
          for j in range(len(x)):
            cpgsci(ci[j])
            cpgerr1(5,x[j],y[j],ex[j],bar)
            cpgerr1(6,x[j],y[j],ey[j],bar)
        else:
          cpgsci(ci)
          cpgerrx(n,x-ex,x+ex,y,bar)
          cpgerry(n,x,y-ey,y+ey,bar)
        cpgsci(1)
        cpgslw(1)

def drawpterr2(x,ex1,ex2,y,ey1,ey2,ps=17,ch=1.5,ci=1,lw=1,bar=0.1):
        x = asarray(x)
        y = asarray(y)
        ex1 = asarray(ex1)
        ey1 = asarray(ey1)
        ex2 = asarray(ex2)
        ey2 = asarray(ey2)

        n=len(x)
        if len(shape(ch)) == 0: cpgsch(ch)
        cpgslw(lw)
        if len(shape(ci)) > 0:
          for j in range(len(x)):
            cpgsci(ci[j])
            if len(shape(ch)) > 0:
               cpgsch(ch[j])
            cpgerrx(1,x[j:j+1]-ex1[j:j+1],x[j:j+1]+ex2[j:j+1],y[j:j+1],bar)
            cpgerry(1,x[j:j+1],y[j:j+1]-ey1[j:j+1],y[j:j+1]+ey2[j:j+1],bar)
        else:
          cpgsci(ci)
          cpgerrx(n,x-ex1,x+ex2,y,bar)
          cpgerry(n,x,y-ey1,y+ey2,bar)
        cpgsci(1)
        cpgslw(1)

def drawpt(x,y,ps=17,ch=1.5,ci=1,lw=1):

        x = asarray(x)
        y = asarray(y)
        n=len(y)
        cpgsch(ch)
        cpgslw(lw)
        if len(shape(ci)) > 0:
          for j in range(len(y)):
            cpgsci(ci[j])
            cpgpt1(x[j],y[j],ps)
        else:
          cpgsci(ci)
          cpgpt(n,x,y,ps)
        cpgsci(1)
        cpgslw(1)

def drawfn(x,f,ls=1,lw=1,ci=1):

	y=eval(f)
        cpgsci(ci)
        cpgsls(ls)
        cpgslw(lw)
        cpgline(len(x),x,y)
        cpgsls(1)
        cpgslw(1)
        cpgsci(1)

def drawbin(x,y,ls=1,lw=1,ci=1,center=1):
        x = asarray(x)
        y = asarray(y)

        n=len(x)
        cpgsci(ci)
        cpgsls(ls)
        cpgslw(lw)
        cpgbin(n,x,y,center)
        cpgsls(1)
        cpgslw(1)
        cpgsci(1)

def arrow(x,y,ch=1,ls=1,lw=1,ci=1):
        cpgsch(ch)
        cpgsci(ci)
        cpgsls(ls)
        cpgslw(lw)
        cpgarro(x[0],y[0],x[1],y[1])
        cpgsch(1)
        cpgsci(1)
        cpgsls(1)
        cpgslw(1)

def drawln(x,y,ls=1,lw=1,ci=1,hist=0):
        x = asarray(x)
        y = asarray(y)

        n=len(x)
        cpgsci(ci)
        cpgsls(ls)
        cpgslw(lw)
        if hist and "giza" not in os.environ["PGPLOT_DIR"]: cpgbin(n,x,y,1)
        else: cpgline(n,x,y)
        cpgsls(1)
        cpgslw(1)
        cpgsci(1)

def imtitle(label,ch=2,lw=1):
        cpgslw(lw)
        cpgsch(ch)
	cpgstbg(0)
	cpgmtxt('T',0.5,0.05,0.0,label)
        cpgslw(1)

def title(label,ch=2,lw=1,ci=1):
        cpgslw(lw)
        cpgsch(ch)
        cpgsci(ci)
        cpgmtxt('T',1.5, 0.5,0.5,label)
        cpgslw(1)

def subtitle(label,ch=2,lw=1,ci=1):
        cpgslw(lw)
        cpgsch(ch)
        cpgsci(ci)
        cpgmtxt('T',0.5, 0.5,0.5,label)

def xlabel(label,ch=2,lw=1,asp=1.0,dist=2.3,ci=1,cen=0.5,fj=0.5):
        cpgslw(lw)
        cpgsch(ch)
        cpgsci(ci)
        cpgmtxt('B',dist+(asp*0.5/ch),cen,fj,label)
        cpgslw(1)

def ylabel(label,ch=2,lw=1,asp=1.0,cen=0.5,dist=1.73,ci=1,fj=0.5):
        cpgslw(lw)
        cpgsch(ch)
        cpgsci(ci)
        cpgmtxt('L',dist+(asp*0.5/ch),cen,fj,label)
        cpgslw(1)

def rlabel(label,ch=2,lw=1,asp=1.0,dist=2.0):
        cpgslw(lw)
        cpgsch(ch)
        cpgmtxt('R',dist+(asp*0.5/ch),0.5,0.5,label)
        cpgslw(1)

def closedev(ask=0,sdev=None,fo=False,pstopdf=False):
	if sdev:
          cpgslct(sdev)
        f = cpgqinf("FILE")[0]
#        if f.split(".")[-1] in ["png"]:
#           if os.path.exists(f): os.remove(f)
	cpgask(ask)
	cpgclos()
#        print f
        if pstopdf and f[-2:] == "ps":
           verbsh("fixout "+f)
           if os.uname()[0] == "Darwin":
              verbsh("pstopdf "+f)
           else:
              verbsh("ps2pdf "+f)
        if fo:
          if f[-2:] == "ps":
             if pstopdf:
                verbsh("open "+".".join(f.split(".")[:-1]+["pdf"]))
             else: verbsh("open "+f)
          elif f: verbsh("open "+f)
        return f


def getcurs(x,y,trf=[0,1,0,0,0,1]):
        status,x,y,key= cpgcurs(x,y)
	xi = int((x-trf[0])/trf[1])
	yi = int((y-trf[3])/trf[5])
	return [key,(x,y),(xi,yi)]

def wrttext(oldwrt,newwrt,dist=2.5,ch=1,len=-0.05,along='B',lw=1,fj=0,ci=1,tbg=0):
        cpgsch(ch)
        cpgslw(lw)
	if oldwrt != newwrt:
		cpgsci(0)
		cpgmtxt(along,dist,len,fj,oldwrt)
		cpgsci(ci)

	cpgstbg(tbg)
	cpgmtxt(along,dist,len,fj,newwrt)
        cpgslw(1)

def showpt(oxi,oyi,xi,yi,sym=4):
    if oxi != xi and oyi != yi:
	cpgsci(0)
	cpgslw(3)
	cpgpt1(oxi,oyi,sym)

    cpgsci(2)
    cpgslw(3)
    cpgpt1(xi,yi,sym)
    cpgslw(1)
    cpgsci(1)

def showcross(oxi,oyi,xi,yi,ls=1,pa=0.0):
    if oxi != xi or oyi != yi:
	cpgsci(0); cpgsls(ls)
	x1 = oxi + 3276700*cos(pa); x2 = oxi - 3276700*cos(pa)
	y1 = oyi - 3276700*sin(pa); y2 = oyi + 3276700*sin(pa)
	cpgmove(x1,y1); cpgdraw(x2,y2)
	x1 = oxi - 3276700*sin(pa); x2 = oxi + 3276700*sin(pa)
	y1 = oyi - 3276700*cos(pa); y2 = oyi + 3276700*cos(pa)
	cpgmove(x1,y1); cpgdraw(x2,y2)

    cpgsci(2); cpgsls(ls)
    x1 = xi + 3276700*cos(pa); x2 = xi - 3276700*cos(pa)
    y1 = yi - 3276700*sin(pa); y2 = yi + 3276700*sin(pa)
    cpgmove(x1,y1); cpgdraw(x2,y2)
    x1 = xi - 3276700*sin(pa); x2 = xi + 3276700*sin(pa)
    y1 = yi - 3276700*cos(pa); y2 = yi + 3276700*cos(pa)
    cpgmove(x1,y1); cpgdraw(x2,y2)
    cpgsls(1); cpgsci(1)

def drawslit(x,y,ci=7,lw=1,ls=1):
        x = asarray(x)
        y = asarray(y)
	cpgsci(ci)
	cpgslw(lw)
	cpgsls(ls)
	cpgline(len(x),x,y)
	cpgslw(1)
	cpgsci(1)
	cpgsls(1)

def drawbox(x,y,ci=1,ls=1,lw=1,fs=0,angle=45.0,sepn=1.0,phase=0.0):
        x = asarray(x)
        y = asarray(y)
	cpgsls(ls)
	cpgsci(ci)
	cpgslw(lw)
        cpgshs(angle,sepn,phase)
        if fs > 0:
	  cpgsfs(fs)
	  cpgpoly(len(x),x,y)
	  cpgsfs(1)
        else:
	  cpgline(len(x),x,y)
	cpgslw(1)
	cpgsls(1)
	cpgsci(1)

def qplot(x,y,m='p',dev="/xserv",close=1,new=1,ps=4,ls=1,ci=1,xm=0,ym=10,ch=2):
  if new: 
     opendev(dev,size=getpgdev()[1])
  if new or not close: 
     if len(shape(xm)) == 0: xm = getmar(x,xm,xm)
     if len(shape(ym)) == 0: ym = getmar(y,ym,ym)
     newbox(xm,ym, ch=ch)
  if m == 'l': drawln(x,y,ls,ci=ci)
  else: drawpt(x,y,ps=ps,ci=ci,ch=ch)
  if close: closedev(1)

def qhist(x,nbin=20,ch=2,amp=1.5,lolim=None,uplim=None,new=1,ci=1):
   if lolim == None: xmin = min(x)
   else: xmin=lolim
   if uplim == None: xmax = max(x)
   else: xmax=uplim
   ymax = amp*len(x)/sqrt(nbin)
   if new: newbox( (xmin,xmax), (0,ymax), ch=ch)
   cpgsci(ci)
   cpghist( len(x), x, xmin, xmax, nbin, 1)
   cpgsci(1)

def drawcirc(x,y,r,ci=1,ls=1,lw=1,fs=2):
    cpgsls(ls)
    cpgsfs(fs)
    cpgsci(ci)
    cpgslw(lw)
    cpgcirc(x,y,r)
    cpgslw(1)
    cpgsls(1)
    cpgsci(1)
    cpgsfs(1)


